/***************************************************************************
                          Xserver.c  -  description
                             -------------------
    begin                : 28.03.04
    copyright            : (C) 2004 by Pablo Yanez Trujillo
    email                : rex@supertux.homelinux.org
    Version			: 1.0.2
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "Xresources.h"
#include "common.h"
#include "debugoutput.h"

Display* connectX(Display* disp)
{
    char* dispname=NULL;
    disp=NULL;
    if (NULL==(disp=XOpenDisplay(dispname))) {
        fprintf(stderr, "Cannot connect with the X Server\n");
	exit(EXIT_FAILURE);
    }
    dfprintf(output, "Connection successfully made with the X Server under \"%s\"\n", XDisplayName(dispname));
    return disp;
}

void closeX(Display* disp)
{
    if (disp==NULL) return;
    XCloseDisplay(disp);
    dfprintf(output, "Connection successfully closed with the X Server\n");
}

void get_size(Display* disp, size_t* width, size_t* height)
{
    size_t screenNum;
    if (disp==NULL || width==NULL || height==NULL) {
        fprintf(stderr, "I lost information about how to connect with the X Server\n");
	exit(EXIT_FAILURE);
    }
    screenNum = DefaultScreen(disp);
    dfprintf(output, "On Screen %d:\n", screenNum);
    *width=getRootWidth(disp, screenNum);
    dfprintf(output, "  Root.width=%d\n", *width);
    *height=getRootHeight(disp, screenNum);
    dfprintf(output, "  Root.height=%d\n", *height);
}

size_t getRootWidth(Display* disp, size_t screenNum)
{
    if (disp==NULL) return 0;
    return DisplayWidth(disp, screenNum);
}

size_t getRootHeight(Display* disp, size_t screenNum)
{
    if (disp==NULL) return 0;
    return DisplayHeight(disp, screenNum);
}
