/***************************************************************************
                          db.c  -  description
                             -------------------
    begin                : 11.04.04
    copyright            : (C) 2004 by Pablo Yanez Trujillo
    email                : rex@supertux.homelinux.org
    Version			: 1.0.2
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "db.h"
#include "common.h"
#include "debugoutput.h"

void add_files(TREE* tree, const char* dir, int* id, int root, INFO* info)
{
    DIR* directory;
    struct dirent* dirInfo;
    char buffer[MAX_LENGTH], text[MAX_LENGTH], curr[MAX_LENGTH];
    int i;

        
    if (!tree || !dir || !id) return;
    
    buffer[0]=0;
    for(i=0; i<root; ++i)
       strcat(buffer, " ");

    sprintf(text, "%s", dir);
    strcat(buffer, text);
    dfprintf(output, buffer);
    if (NULL==(directory=opendir(dir))) {
       dfprintf(output, " (cannot be opened)\n");
       return;
    }
    dfprintf(output, " (opened)\n");
    buffer[0]=0;
    for(i=0; i<root+2; ++i)
       strcat(buffer, " ");

    while ((dirInfo = readdir(directory)) != NULL) {
	// 4 is directory, 8 is file
	if(strcmp(dirInfo->d_name, ".") && strcmp(dirInfo->d_name, "..") && strcmp(dirInfo->d_name, ".xvpics")) {
	    /* .xvpics for The GIMP */
	    if (dirInfo->d_type==4) {
	        strcpy(curr, dir);
		if (curr[strlen(curr)-1]!='/') strcat(curr, "/");
		strcat(curr, dirInfo->d_name);
	        add_files(tree, curr, id, root+2, info);
	    }
	    else {
	        if (isPicture(dirInfo->d_name, info)) {
		    strcpy(curr, dir);
		    if (curr[strlen(curr)-1]!='/') strcat(curr, "/");
		    strcat(curr, dirInfo->d_name);
		    if (!haveName(tree, curr)) {
		        if (addElement(tree, curr, ++(*id))) 
			    dfprintf(output, "%s%s (added)\n", buffer, curr);
			else --(*id);
		    }
		}
	    }
	}
    }
    closedir(directory);
}
